import java.util.*;
import java.io.*;
import java.lang.*;

public class Embrulho {
    private Vector pontos; 
    private int TSleep = 0;
    private f3d tela;



    public Embrulho(f3d tela) {
	this.tela = tela;
    }

    public void setTSleep(int time){
	this.TSleep = time;
    }


    public void Algoritmo() {
	WE we = new WE();
	Fila fila = new Fila();
	FaceWE face = new FaceWE();
	ArestaWE e;
	Vector arestasLivres;
	pontos = new Vector();
	VerticeWE vertice1;
	VerticeWE vertice2;
	PontoWE ponto;
	PontoWE candidato;

	LePontos("entrada.dat");
	ImprimePontos(pontos, tela);
	
	// fazemos a consistencia de entrada (ter pelo menos 4 pontos)
	if (pontos.size() < 4) {
	    System.out.println("Para determinarmos o fecho convexo precisamos de pelo menos 4 pontos distintos");
	    System.exit(0);
	}

	// Vamos agora achar uma face do fecho convexo

	// comecaremos pelo ponto de menor coordenada z. (em caso de empate y, e se continuar empatado o x)
	ponto = (PontoWE) pontos.elementAt(0);
	for (int i = 1; i < pontos.size(); i++) {
	    candidato = (PontoWE) pontos.elementAt(i);
	    if (candidato.getZ() < ponto.getZ()) {
		ponto = candidato;
	    } else if (candidato.getZ() == ponto.getZ()) {
		if (candidato.getY() < ponto.getY()) {
		    ponto = candidato;
		} else if (candidato.getY() == ponto.getY()) {
		    if (candidato.getX() < ponto.getX()) {
			ponto = candidato;
		    }
		}
	    }
	}

	// achei o primeiro vertice (vertice1)
	vertice1 = new VerticeWE(ponto.getX(), ponto.getY(), ponto.getZ());
	vertice2 = new VerticeWE(ponto.getX(), ponto.getY() - 1, ponto.getZ());

	System.out.println("Face inicial:");
	System.out.println("Vertice1: (" + vertice1.getX() + "," + vertice1.getY() + "," + vertice1.getZ() + ")");


	// criamos uma falsa aresta
	e = new ArestaWE();
	e.verticeInicial = vertice1;
	e.verticeFinal = vertice2;

	// primeiro embrulho pra presente para achar o segundo vertice da primeira face
	ponto = passoEmbrulhoPraPresente(tela, e);
	
	vertice2 = new VerticeWE(ponto.getX(), ponto.getY(), ponto.getZ());
	System.out.println("Vertice2: (" + vertice2.getX() + "," + vertice2.getY() + "," + vertice2.getZ() + ")");

	e = new ArestaWE();
	e.verticeInicial = vertice1;
	e.verticeFinal = vertice2;
	we.getVetArestas().add(e);


	// segundo passo embrulho para presente, completando a primeira face do fecho convexo
	ponto = passoEmbrulhoPraPresente(tela, e);
	System.out.println("Vertice3: (" + ponto.getX() + "," + ponto.getY() + "," + ponto.getZ() + ")");

	// pinta(face)
	//try { Thread.sleep(TSleep); } catch (Exception erro) {}
	desenhaLinha(tela, e.verticeInicial, e.verticeFinal);
	desenhaLinha(tela, e.verticeFinal, ponto);
	desenhaLinha(tela, ponto, e.verticeInicial);
	try { Thread.sleep(TSleep); } catch (Exception erro) {}
	fila.Insere(we.InsereFace(e, ponto));
	int contFace = 0;
	
	while (!fila.isFilaVazia()) {
	    face = (FaceWE) fila.Remove();
	    arestasLivres = face.getArestasLivres();
	    System.out.println("\nNumero de arestas livres: " + arestasLivres.size());
	    for (int i = 0; i < arestasLivres.size(); i++) {
		System.out.println("\nNova face:" + ++contFace);
		System.out.print("Aresta Livre " + i + ": ");
		e = (ArestaWE) arestasLivres.elementAt(i);
		ponto = passoEmbrulhoPraPresente(tela, e);
		System.out.println("Ponto vencedor: (" + ponto.getX() + "," + ponto.getY() + "," + ponto.getZ() + ")");
		// pinta(face)
		try { Thread.sleep(TSleep); } catch (Exception erro) {}
		desenhaLinha(tela, e.verticeInicial, e.verticeFinal);
		desenhaLinha(tela, e.verticeFinal, ponto);
		desenhaLinha(tela, ponto, e.verticeInicial);
		fila.Insere(we.InsereFace(e, ponto));
	    }
	}


	// agora iremos retirar as arestas que ligam faces de um mesmo plano
	Vector arestas;
	ArestaWE aresta;
	VerticeWE cand;
	ArestaWE acand;
	arestas = we.getVetArestas();
	System.out.println("**************** Removendo arestas coplanares **********************");
	System.out.println("Numero total de arestas eh = "+arestas.size());
	for (int cont = 0; cont < arestas.size(); cont++) {
	    aresta = (ArestaWE) arestas.elementAt(cont);

	    if(aresta.pccw==null || aresta.ncw==null){
		System.out.println("*** Aresta "+aresta.print()+" tem pccw  ou ncw null!!!");
		//apagaLinha(tela,aresta.verticeInicial, aresta.verticeFinal);
	    }else{
		if(aresta.pccw.verticeFinal.isCoincidente(aresta.verticeFinal)   ||
		   aresta.pccw.verticeInicial.isCoincidente(aresta.verticeFinal) ||
		   aresta.ncw.verticeFinal.isCoincidente(aresta.verticeFinal)    ||
		   aresta.ncw.verticeInicial.isCoincidente(aresta.verticeFinal)
		   ){
		    System.out.println("Caso Filho da puta!!");
		}else{
		//if(aresta.ncw==null)
		//  System.out.println("Aresta "+aresta.print()+" tem ncw");
		
		if (aresta.verticeInicial.isCoincidente(aresta.pccw.verticeFinal)) {
		    vertice1 = aresta.pccw.verticeInicial;
		} else {
		    vertice1 = aresta.pccw.verticeFinal;
		}
		if (aresta.verticeInicial.isCoincidente(aresta.ncw.verticeFinal)) {
		    vertice2 = aresta.ncw.verticeInicial;
		} else {
		    vertice2 = aresta.ncw.verticeFinal;
		}
		System.out.println("Testando aresta "+aresta.print());
		System.out.println(" apos comparar com "+vertice1.print()+" e "+vertice2.print());
		//vertice2 = aresta.pcw.verticeFinal;
		if (Primitivas.Volume6(aresta.verticeInicial, aresta.verticeFinal, vertice1, vertice2) == 0) {
		    System.out.print("Apagou "+aresta.print());
		    System.out.println(" apos comparar com "+vertice1.print()+" e "+vertice2.print());
		    apagaLinhaTudo(tela,aresta.verticeInicial, aresta.verticeFinal);
		}
		}//end of else caso vtcc.
	    }//end of else.
	}//end of for.
	System.out.println("ACABOU REMOCAO");



    }




    private PontoWE passoEmbrulhoPraPresente(f3d tela, ArestaWE e) {
	PontoWE ponto;
	PontoWE candidato;
	VerticeWE vertice1;
	VerticeWE vertice2;

	vertice1 = e.verticeInicial;
	vertice2 = e.verticeFinal;
	ponto = getPontoDiferente(vertice1, vertice2);
	
	System.out.print("(" + vertice1.getX() + "," + vertice1.getY() + "," + vertice1.getZ() + ")");
	System.out.println(" -> (" + vertice2.getX() + "," + vertice2.getY() + "," + vertice2.getZ() + ")");
	
	//System.out.println("Ponto atual: (" + ponto.getX() + "," + ponto.getY() + "," + ponto.getZ() + ")");
	/**
	 * Aqui desenhamos triangulo pro ponto candidato.
	 */
	desenhaLinhaAresta( tela, vertice1, vertice2 );
	desenhaLinhaVencedora( tela, vertice1, ponto );
	desenhaLinhaVencedora( tela, ponto, vertice2 );
	
	/**
	 * Fim da alteracao.
	 */
	int j = 0;
	while (j < pontos.size()) {
	    candidato = (PontoWE) pontos.elementAt(j);
	    
	    if (!isPontoRepetido(candidato, vertice1, vertice2, ponto)) {
		//System.out.println("Ponto candidato: (" + candidato.getX() + "," + candidato.getY() + "," + candidato.getZ() + ")");
		/**
		 * Aqui desenhamos triangulo pro ponto candidato.
		 */
		
		desenhaLinhaCandidata( tela, vertice1, candidato );
		desenhaLinhaCandidata( tela, candidato, vertice2 );
		
		try { Thread.sleep(TSleep); } catch (Exception erro) {}
		
		apagaLinha( tela, vertice1, candidato );
		apagaLinha( tela, candidato, vertice2 );
		
		
		/**
		 * Fim da alteracao.
		 */
		int volume6 = Primitivas.Volume6(vertice1, vertice2, ponto, candidato);
		if (e.fccw == null) {
		    if (volume6 > 0) {
			apagaLinha( tela, vertice1, ponto );
			apagaLinha( tela, ponto, vertice2 );
			
			ponto = candidato;
			
			desenhaLinhaVencedora( tela, vertice1, ponto );
			desenhaLinhaVencedora( tela, ponto, vertice2 );
			
			//System.out.println("Ponto atual: (" + ponto.getX() + "," + ponto.getY() + "," + ponto.getZ() + ")");
		    } else if (volume6 == 0) {
			if (!candidato.marcado) {
			    candidato.marcado = true;
			    pontos.add(pontos.remove(j));
			    j--;
			} else {
			    candidato.marcado = false;
			}
		    } else {
			candidato.marcado = false;
		    }
		} else {
		    if (volume6 < 0) {
			apagaLinha( tela, vertice1, ponto );
			apagaLinha( tela, ponto, vertice2 );
			
			ponto = candidato;
			
			//System.out.println("Ponto atual: (" + ponto.getX() + "," + ponto.getY() + "," + ponto.getZ() + ")");
			/**
			 * Aqui desenhamos triangulo pro ponto candidato.
			 */
			
			desenhaLinhaVencedora( tela, vertice1, ponto );
			desenhaLinhaVencedora( tela, ponto, vertice2 );
			
			/**
			 * Fim da alteracao.
			 */
		    } else if (volume6 == 0) {
			if (!candidato.marcado) {
			    candidato.marcado = true;
			    pontos.add(pontos.remove(j));
			    j--;
			} else {
			    candidato.marcado = false;
			}
		    } else {
			candidato.marcado = false;
		    }
		}
	    }
	    j++;
	    
	    //apagaLinha(tela, e.verticeFinal, candidato);
	    //apagaLinha(tela, candidato, e.verticeInicial);
	    
	}//end of while 
	apagaLinha(tela, e.verticeInicial, e.verticeFinal);
	apagaLinha(tela, e.verticeInicial, ponto);
	apagaLinha(tela, ponto, e.verticeFinal);
	ponto.marcado = false;

	return(ponto);
    }

    /** devolve um ponto contido no Vector pontos que seja diferente de vertice1 */
    private PontoWE getPontoDiferente(PontoWE vertice1) {
	PontoWE ponto = (PontoWE) pontos.elementAt(0);
	if (isPontoRepetido(ponto, vertice1)) {
	    ponto = (PontoWE) pontos.elementAt(1);
	}
	return(ponto);
    }

    /** devolve um ponto contido no Vector pontos que seja diferente de vertice1 e vertice2 */
    private PontoWE getPontoDiferente(PontoWE vertice1, PontoWE vertice2) {
	PontoWE ponto = (PontoWE) pontos.elementAt(0);
	if (isPontoRepetido(ponto, vertice1, vertice2)) {
	    ponto = (PontoWE) pontos.elementAt(1);
	    if (isPontoRepetido(ponto, vertice1, vertice2)) {
		ponto = (PontoWE) pontos.elementAt(2);
	    }
	}
	return(ponto);
    }


    /** verificamos se as coordenadas de ponto eh igual as do vertice1 */
    private boolean isPontoRepetido(PontoWE ponto, PontoWE vertice1) {
	return((ponto.getX() == vertice1.getX()) && (ponto.getY() == vertice1.getY()) && (ponto.getZ() == vertice1.getZ()));
    }


    /** verificamos se as coordenadas de ponto eh igual as do vertice1 ou as do vertice2 */
    private boolean isPontoRepetido(PontoWE ponto, PontoWE vertice1, PontoWE vertice2) {
	return(isPontoRepetido(ponto, vertice1) || isPontoRepetido(ponto, vertice2));
    }


    /** verificamos se as coordenadas de ponto eh igual as do vertice1 ou as do vertice2 ou as do vertice3 */
    private boolean isPontoRepetido(PontoWE ponto, PontoWE vertice1, PontoWE vertice2, PontoWE vertice3) {
	return(isPontoRepetido(ponto, vertice1) || isPontoRepetido(ponto, vertice2) || isPontoRepetido(ponto, vertice3));
    }



    /** Imprimimos as coordenadas dos pontos do Vector pontos */
    private void ImprimePontos(Vector pontos, f3d tela) {
	PontoWE ponto;
	for (int i = 0; i < pontos.size(); i++) {
	    ponto = (PontoWE) pontos.elementAt(i);
	    System.out.println("Ponto " + i + ": (" + ponto.getX() + "," + ponto.getY() + "," + ponto.getZ() + ")");
	    tela.inserePonto(pontoWE2Ponto3D(ponto));
	}
    }

    /** Le os pontos de entrada */
    private void LePontos(String filename) {
	try {
	    try {
		LeArquivo(filename);
	    } catch (IOException e1) {}
	} catch (FormatoArquivoIncorretoException e2) {}
    }


    /** Le o arquivo enviado como parametro, e cria os pontos de entrada */
    private void LeArquivo(String nome_arq_entrada) throws
    FormatoArquivoIncorretoException, IOException 
    {
	File arquivoEntrada = new File(nome_arq_entrada);
	FileInputStream in = new FileInputStream(arquivoEntrada);

	int numero;
	int x, y, z = 0;
	int sinal;

	// le primeiro caractere do arquivo
	int c = in.read();
      
	// Le o numero de entradas
	numero = 0;
	while (Character.isWhitespace((char) c) && c > -1)
	    c = in.read();
	// se o caractere eh um numero 
	if  (Character.isDigit( (char) c )){
	    numero = 0;
	    while (Character.isDigit( (char) c )){
		numero = numero * 10 + c - '0';
		c = in.read();
	    }
	}

	for(int i = 0; i < numero; i++){
	    // Le a coordenada x
	    x = 0; sinal = 1;
	    while (Character.isWhitespace((char) c) && c > -1)
		c = in.read();
	    // se o caractere eh um numero
	    if (((char) c) == '-') {
		sinal = -1;
		c = in.read();
	    }
	    if  (Character.isDigit( (char) c )){
		while (Character.isDigit( (char) c )){
		    x = x * 10 + c - '0';
		    c = in.read();
		}
		x *= sinal;
	    }
	    

	    // Le a coordenada y
	    y = 0; sinal = 1;
	    while (Character.isWhitespace((char) c) && c > -1)
		c = in.read();
	    // se o caractere eh um numero 
	    if (((char) c) == '-') {
		sinal = -1;
		c = in.read();
	    }
	    if  (Character.isDigit( (char) c )){
		while (Character.isDigit( (char) c )){
		    y = y * 10 + c - '0';
		    c = in.read();
		}
		y *= sinal;
	    }

	    // Le a coordenada z
	    z = 0; sinal = 1;
	    while (Character.isWhitespace((char) c) && c > -1)
		c = in.read();
	    // se o caractere eh um numero 
	    if (((char) c) == '-') {
		sinal = -1;
		c = in.read();
	    }
	    if  (Character.isDigit( (char) c )){
		while (Character.isDigit( (char) c )){
		    z = z * 10 + c - '0';
		    c = in.read();
		}
		z *= sinal;
	    }

	    NovoPonto(x, y, z);
	    
	    // muda de linha
	    while (c != '\n') 
		c = in.read();	
	}
    }



    /** cria um novo PontoWE a partir das coordenadas dadas */
    private void NovoPonto(int x, int y, int z) {
	PontoWE ponto = new PontoWE(x, y, z);
	pontos.add(ponto);
    }


    private void desenhaLinha(f3d tela, PontoWE vertice1, PontoWE vertice2) {
	Ponto3D p1;
	Ponto3D p2;
	Cor c = new Cor(0.0f, 1.0f, 1.0f);
	p1 = pontoWE2Ponto3D(vertice1);
	p2 = pontoWE2Ponto3D(vertice2);
	tela.insereLinha(new Linha(p1, p2, c));
    }

    private void desenhaLinhaCandidata(f3d tela, PontoWE vertice1, PontoWE vertice2) {
	Ponto3D p1;
	Ponto3D p2;
	Cor c = new Cor(1.0f, 1.0f, 1.0f);
	p1 = pontoWE2Ponto3D(vertice1);
	p2 = pontoWE2Ponto3D(vertice2);
	tela.insereLinha(new Linha(p1, p2, c));
    }

    private void desenhaLinhaVencedora(f3d tela, PontoWE vertice1, PontoWE vertice2) {
	Ponto3D p1;
	Ponto3D p2;
	Cor c = new Cor(0.0f, 1.0f, 0.0f);
	p1 = pontoWE2Ponto3D(vertice1);
	p2 = pontoWE2Ponto3D(vertice2);
	tela.insereLinha(new Linha(p1, p2, c));
    }

    private void desenhaLinhaAresta(f3d tela, PontoWE vertice1, PontoWE vertice2) {
	Ponto3D p1;
	Ponto3D p2;
	Cor c = new Cor(1.0f, 0.0f, 0.0f);
	p1 = pontoWE2Ponto3D(vertice1);
	p2 = pontoWE2Ponto3D(vertice2);
	tela.insereLinha(new Linha(p1, p2, c));
    }


    private void apagaLinha(f3d tela, PontoWE vertice1, PontoWE vertice2) {
	Ponto3D p1;
	Ponto3D p2;
	Cor c = new Cor(0.0f, 0.0f, 0.0f);
	p1 = pontoWE2Ponto3D(vertice1);
	p2 = pontoWE2Ponto3D(vertice2);
	tela.removeLinha(new Linha(p1, p2, c));
    }

    private void apagaLinhaTudo(f3d tela, PontoWE vertice1, PontoWE vertice2) {
	Ponto3D p1;
	Ponto3D p2;
	Cor c = new Cor(0.0f, 0.0f, 0.0f);
	p1 = pontoWE2Ponto3D(vertice1);
	p2 = pontoWE2Ponto3D(vertice2);
	tela.arrancaLinha(new Linha(p1, p2, c));
    }


    private Ponto3D pontoWE2Ponto3D(PontoWE ponto) {
	return(new Ponto3D((float) ponto.getX(), (float) ponto.getY(), (float) ponto.getZ()));
    }


    /** funcao principal do programa */
    //public static void main(String argv[]) {
    //new Embrulho();
    //if (argv.length > 0)
    //    new Embrulho(argv[0]);
    //else{
    //    System.out.println("Uso: java Embrulho nomedoarquivo.dat");
    //}
    //}
}//end of class.

