import java.util.*;
import java.io.*;

/**
 * Class Fila.
 * Armazena e remove dados na forma FIFO.
 */
public class Fila {

    private Vector vet;
    
    /**
     * Construtor.
     */
    public Fila(){
	vet = new Vector();
    }
    /**
     * Insere um elemento no FIM da fila.
     * 
     */
    public void Insere(Object obj){
      vet.addElement(obj);
    }
    /**
     * Devolve o PRIMEIRO elemento da fila e o REMOVE da fila.
     * Se a fila estiver vazia, devolve null.
     */
    public Object Remove(){
      if(isFilaVazia())
	return null;
      return (vet.remove(0));
    }

    /**
     * Devolve o PRIMEIRO elemento na fila MANTENDO-O na fila.
     * Se a fila estiver vazia, devolve null.
     */
    public Object Primeiro(){
      if(isFilaVazia())
	return null;
      return (vet.elementAt(0));

    }

    public boolean isFilaVazia(){
      return ( vet.size() <= 0 );
    }

  public int Tamanho(){
    return vet.size();
  }

  public static void main(String args[]){
    VerticeWE v1 = new VerticeWE(1,1,1);
    VerticeWE v2 = new VerticeWE(2,2,2);
    VerticeWE v3 = new VerticeWE(3,3,3);

    Fila f = new Fila();
    f.Insere(v1);
    f.Insere(v2);
    f.Insere(v3);

    while(!f.isFilaVazia()){
      VerticeWE v = (VerticeWE) f.Remove();
      System.out.println("Esse vertice tem coordenada x="+v.getX());
    }

  }


}//end of class


