/**
 * Esta Classe fornce primitivas matematicas para o Algoritmo de Embrulho pra Presente 3D.
 *
 */

public  class Primitivas{
    private static int DIMENSAO = 3;
    private static int[][] M = new int[DIMENSAO+1][DIMENSAO+1];

    /**
     * Devolve um numero maior que zero se p3 estiver acima do plano formado por p0,p1,p2.
     * Devolve zero se p3 estiver no plano formato pelos outros 3 pontos.
     * Devolve um numero negativo c.c.
     */
    public static int Volume6(PontoWE p0, PontoWE p1, PontoWE p2, PontoWE p3){
	/**
	 * INICIALIZANDO A MATRIZ.
	 */
	
	//Primeiro preenchemos a ultima coluna com tudo zero.
	for(int i=0; i<=DIMENSAO; i++){
	    M[i][DIMENSAO]=1;
	}
	M[0][0]=p0.getX();
	M[0][1]=p0.getY();
	M[0][2]=p0.getZ();
	M[1][0]=p1.getX();
	M[1][1]=p1.getY();
	M[1][2]=p1.getZ();
	M[2][0]=p2.getX();
	M[2][1]=p2.getY();
	M[2][2]=p2.getZ();
	M[3][0]=p3.getX();
	M[3][1]=p3.getY();
	M[3][2]=p3.getZ();
	return Determinante(M, DIMENSAO+1);
    }
    /**
     * Calcula o determinante de uma matriz de dimensao N x N.
     * @param M Matriz cujo determinante queremos calcular.
     * @param N tamanho da matriz M.
     * @return Determinante da matriz M.
     */
    public static int Determinante(int B[][], int N){
	int det=0;

	//System.out.println("Recebeu matriz :");

	//for(int a=0; a< N; a++){
	//  for(int b=0; b < N; b++)
	//System.out.print(B[a][b]+" ");
	//  System.out.println();
	//}

	/**
	 * Bases da nossa recurso.
	 */

	if(N == 2){
	  //System.out.println("Resultado dessa submatriz : "+ (B[0][0]*B[1][1]-B[0][1]*B[1][0]));
	  return( B[0][0]*B[1][1]-B[0][1]*B[1][0] );
	}
	if(N == 1){
	    return ( B[0][0] );
	}
	//System.out.println("Matriz tam="+N);
	//Primeiro criamos a nova matriz.
	int[][]A = new int[N-1][N-1]; //Matriz auxiliar.
	
	for(int n=0; n < N; n++){
	    for(int i=0; i < N-1; i++){
		for(int j=0; j < N-1 ; j++){
		    if(j < n){
			A[i][j]=B[i+1][j];
			
		    }
		    if(j >= n){
			A[i][j]=B[i+1][j+1];
			
		    }
		}//end of for j.
	    }//end of for i.
	    //System.out.println("n = "+n);
	    //for(int a=0; a< N-1; a++){
	    //for(int b=0; b < N-1; b++)
	    //System.out.print(A[a][b]+" ");
	    //System.out.println();
	    //}
	    int subdet = 0;
	    if(n % 2==0){
	      subdet = Determinante(A, N-1 );
	      det += B[0][n] * subdet;
	      //System.out.println("*** Positivo B[0]["+n+"]="+B[0][n]+" subdet="+subdet+" det="+det);
	    }else{
	      subdet = Determinante(A, N-1);
	      det -= B[0][n] * subdet;
	      //System.out.println("*** Negativo B[0]["+n+"]="+B[0][n]+" det="+det);
	    }
	}//end of for n.
    
	return det;
    }

    public static void  main(String args[]){
	PontoWE v1 = new PontoWE(3,4,0);
	PontoWE v2 = new PontoWE(2,3,0);
	PontoWE v3 = new PontoWE(0,0,0);
	PontoWE v4 = new PontoWE(4,4,0);

	System.out.println(Primitivas.Volume6(v1,v2,v3,v4));

    }

}//end of class. 
