import java.util.*;


/** Estrutura Winged-Edge */
public class WE {

  Vector vetArestas;
  Vector vetVertices;
  Vector vetFaces;

    public WE() {
      vetArestas = new Vector();
      vetVertices = new Vector();
      vetFaces = new Vector();
    }
  
  /**
   * Essa funcao eh fundamental!!
   * Ela recebe uma aresta livre e o ponto que se tornarah vertice do fecho convexo,
   * liga a aresta ao vertice criando mais duas arestas e consequentemente uma face, 
   * seta tudo e devolve a face criada.
   * @param aresta Aresta livre.
   * @param ponto  Ponto que serah ligado por mais duas arestas a aresta livre.
   * @return Retorna a face criada ou null caso aresta ou ponto sejam null.
   */
    public FaceWE InsereFace(ArestaWE aresta, PontoWE ponto) {
      ArestaWE aresta1 = new ArestaWE();
      ArestaWE aresta2 = new ArestaWE();
      
      //System.out.println("***** Entrou em WE::InsereFace() *****");

      if(aresta==null || ponto==null)
	return null;

      FaceWE face = new FaceWE(aresta); //face -> aresta
      VerticeWE v = new VerticeWE(ponto.getX(), ponto.getY(), ponto.getZ());
      v.setAresta(aresta1);
      //Procuramos pelo lado livre da Aresta.
      // *** LADO ESQUERDO ***
      if(aresta.fccw==null){
	//System.out.println("WE::insereFace() criou face no fccw de aresta");
	//Ligamos a aresta ao vertice usando as 2 novas arestas.
	aresta2.verticeInicial = aresta.verticeInicial;
	aresta2.verticeFinal   = v;
	aresta1.verticeInicial = v;
	aresta1.verticeFinal   = aresta.verticeFinal;
	//Caso essa aresta jah nao exista fazemos aresta apontar pra aresta2 e aresta2 apontar pra aresta.
	ArestaWE aresta2JaExistente = getArestaByVertices(aresta.verticeInicial, v);
	if(aresta2JaExistente == null){
	  //System.out.println("** Usando aresta2 nova **");
	  aresta.pccw = aresta2;  //aresta   ->   aresta2
	  aresta2.ncw = aresta;   //aresta2  ->   aresta
	  aresta2.fcw = face;     //aresta2  ->   face. 
	}else{
	  //System.out.println("** Usando aresta2 criada por outro poligono **");
	  aresta2=aresta2JaExistente;
	  aresta.pccw=aresta2;    //aresta   ->   aresta2
	  //Aqui preciso descobrir aonde ligar aresta em aresta2 (jahExistente)
	  if(aresta2.fcw==null){
	    //System.out.println("** aresta2.fcw = face **");
	    aresta2.ncw = aresta; //aresta2  ->   aresta
	    aresta2.fcw = face;   //aresta2  ->   face.
	  }else{
	    //System.out.println("** aresta2.fccw = face **");
	    aresta2.nccw = aresta;//aresta2  ->   aresta
	    aresta2.fccw = face;  //aresta2  ->   face.
	  }
	}
	
	ArestaWE aresta1JaExistente = getArestaByVertices(aresta.verticeFinal, v);
	//Caso essa aresta jah nao exista fazemos aresta apontar pra aresta1 e aresta1 apontar pra aresta.
	if(aresta1JaExistente == null){
	  //System.out.println("** Usando aresta1 nova **");
	  aresta.nccw = aresta1;  //aresta   ->   aresta1
	  aresta1.pcw = aresta;   //aresta1  ->   aresta
	  aresta1.fcw = face;     //aresta1  ->   face.
	}else{
	    //System.out.println("** Usando aresta1 criada por outro poligono **");
	    aresta1 = aresta1JaExistente;
	    aresta.nccw = aresta1;//aresta   ->  aresta1
	    if(aresta1.fcw==null){
		//System.out.println("** aresta1.fcw = face **");
		aresta1.pcw = aresta;  //aresta1  ->  aresta
		aresta1.fcw = face;    //aresta1  ->  face.
	    }else{
		//System.out.println("** aresta1.fccw = face **");
		aresta1.pccw = aresta; //aresta1  ->  aresta
		aresta1.fccw = face;   //aresta1  ->  face.
	    }
	}
	//Apontamos aresta pra essa face e fazemos as aresta1 e aresta2 se apontarem.
	aresta.fccw = face;            //aresta   ->  face.
	
	if(aresta2.verticeInicial == aresta.verticeInicial){
	  aresta2.pcw=aresta1;         //aresta2  ->  aresta1  
	}else{
	  aresta2.pccw=aresta1;        //aresta2  ->  aresta1
	}
	
	if(aresta1.verticeFinal == aresta.verticeFinal){
	  aresta1.ncw=aresta2;         //aresta1  ->  aresta2
	}else{
	  aresta1.nccw=aresta2;        //aresta1  ->  aresta2
	}	

	if(aresta1JaExistente == null)
	  vetArestas.addElement(aresta1); //So adicionamos arestas novas
	if(aresta2JaExistente == null)
	  vetArestas.addElement(aresta2);

	vetFaces.addElement(face);
	//Retornamos a face criada.
	return face;
	// *** LADO DIREITO ***
      }else
	if(aresta.fcw==null){
	  //System.out.println("** WE::insereFace() criou face no fcw de aresta **");
	  //Ligamos a aresta ao vertice usando as 2 novas arestas.
	  aresta2.verticeInicial = aresta.verticeInicial;
	  aresta2.verticeFinal   = v;
	  aresta1.verticeInicial = v;
	  aresta1.verticeFinal   = aresta.verticeFinal;
	  //Caso essa aresta jah nao exista fazemos aresta apontar pra aresta2 e aresta2 apontar pra aresta.
	  ArestaWE aresta2JaExistente = getArestaByVertices(aresta.verticeInicial, v);
	  if(aresta2JaExistente == null){
	    //System.out.println("** Usando aresta2 nova **");
	    aresta.ncw = aresta2;   //aresta   ->   aresta2
	    aresta2.pccw = aresta;  //aresta2  ->   aresta
	    aresta2.fccw = face;    //aresta2  ->   face. 
	  }else{
	    //System.out.println("** Usando aresta2 criada por outro poligono **");
	    aresta2=aresta2JaExistente;
	    aresta.ncw = aresta2;   //aresta   ->   aresta2
	    //Aqui preciso descobrir aonde ligar aresta em aresta2 (jahExistente)
	    if(aresta2.fccw==null){
	      //System.out.println("** aresta2.fccw = face **");
	      aresta2.pccw = aresta;//aresta2  ->   aresta
	      aresta2.fccw = face;  //aresta2  ->   face.
	    }else{
	        //System.out.println("** aresta2.fcw = face **");
	      aresta2.pcw = aresta; //aresta2  ->   aresta
	      aresta2.fcw = face;   //aresta2  ->   face.
	    }
	  }
	  
	  ArestaWE aresta1JaExistente = getArestaByVertices(aresta.verticeFinal, v);
	  //Caso essa aresta jah nao exista fazemos aresta apontar pra aresta1 e aresta1 apontar pra aresta.
	  if(aresta1JaExistente == null){
	    //System.out.println("** Usando aresta1 nova **");
	    aresta.pcw = aresta1;    //aresta   ->   aresta1
	    aresta1.nccw = aresta;   //aresta1  ->   aresta
	    aresta1.fccw = face;     //aresta1  ->   face.
	      }else{
		//System.out.println("** Usando aresta1 criada por outro poligono **");
		aresta1 = aresta1JaExistente;
		aresta.pcw = aresta1;//aresta   ->  aresta1
		if(aresta1.fccw==null){
		  //System.out.println("** aresta1.fccw = face **");
		  aresta1.nccw = aresta;  //aresta1  ->  aresta
		  aresta1.fccw = face;    //aresta1  ->  face.
		}else{
		  //System.out.println("** aresta1.fcw = face **");
		  aresta1.ncw = aresta; //aresta1  ->  aresta
		  aresta1.fcw = face;   //aresta1  ->  face.
		}
	      }
	  //Apontamos aresta pra essa face e fazemos as aresta1 e aresta2 se apontarem.
	  aresta.fcw = face;            //aresta   ->  face.
	  
	  if(aresta2.verticeInicial == aresta.verticeInicial){
	  aresta2.nccw=aresta1;         //aresta2  ->  aresta1  
	  }else{
	    aresta2.ncw=aresta1;        //aresta2  ->  aresta1
	  }
	  
	  if(aresta1.verticeFinal == aresta.verticeFinal){
	    aresta1.pccw=aresta2;         //aresta1  ->  aresta2
	  }else{
	    aresta1.pcw=aresta2;          //aresta1  ->  aresta2
	  }	
	  
	  if(aresta1JaExistente == null)
	      vetArestas.addElement(aresta1);
	  if(aresta2JaExistente == null)
	      vetArestas.addElement(aresta2);

	  vetFaces.addElement(face);
	  return face;
	  
	}else{
	  //System.out.println("WE::InsereFace() Aresta passada no argumento nao eh uma aresta livre!!");
	  System.exit(1);
	}
      
      return null;
    }

  public ArestaWE getArestaByVertices(VerticeWE v1, VerticeWE v2){
    ArestaWE aresta;
    
    //System.out.println("Verificando se ja existe aresta com "+v1.print()+"<->"+v2.print());
    for(int i=0; i < vetArestas.size(); i++){
      aresta = (ArestaWE) vetArestas.elementAt(i);
      //System.out.println(" Comparando com aresta : "+aresta.print());
      if((aresta.verticeInicial.getX()==v1.getX() &&
	  aresta.verticeInicial.getY()==v1.getY() &&
	  aresta.verticeInicial.getZ()==v1.getZ() && 
	  aresta.verticeFinal.getX()==v2.getX() &&
	  aresta.verticeFinal.getY()==v2.getY() &&
	  aresta.verticeFinal.getZ()==v2.getZ()) 
	                 || 
	 (aresta.verticeInicial.getX()==v2.getX() && 
	  aresta.verticeInicial.getY()==v2.getY() &&
	  aresta.verticeInicial.getZ()==v2.getZ() &&
	  aresta.verticeFinal.getX()==v1.getX()&&
	  aresta.verticeFinal.getY()==v1.getY()&&
	  aresta.verticeFinal.getZ()==v1.getZ())
	){
	return aresta;
      }  
    }
    //System.out.println("Nao achou!");
    return null;
  }
  public Vector getVetArestas(){
    return vetArestas;
  }

  public Vector getVetVertices(){
    return vetVertices;
  }

  public Vector getVetFaces(){
    return vetFaces;
  }
  
    public void Imprime() {
      
    }
}


