import java.awt.Panel;
import java.awt.Graphics;
import java.applet.Applet;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ComponentEvent;
import java.awt.event.ComponentListener;

import java.util.Enumeration;
import java.util.Hashtable;

import jgl.GLUT;
import jgl.GL;


public class f3d extends Applet
		  implements ComponentListener, Runnable{

    GL myGL = new GL ();
    GLUT myUT = new GLUT (myGL);

    Hashtable linhas = new Hashtable();

    Thread t;

    int tsleep = 0;

    public void init () {
	myUT.glutInitWindowSize (800, 600);
	myUT.glutInitWindowPosition (0, 0);
	myUT.glutCreateWindow (this);

	myGL.glClearColor (0.0f, 0.0f, 0.0f, 0.0f);
	myGL.glShadeModel (GL.GL_FLAT);
	
	// as call glutReshapeFunc(reshape)
	addComponentListener (this);
	myReshape (getSize ().width, getSize ().height);

	try{
	    tsleep = Integer.parseInt(getParameter("TSleep"));
	}catch(Exception cuc){
	    
	}
	// call display as call glutDisplayFunc(display)
	display ();
    }
    
    public void start()
    {
	t = new Thread(this);
	t.start();
    }
    
    public void stop(){}
    public void run()
    {
	principal();
	
    }
    
    public void componentMoved (ComponentEvent e) {}
    public void componentShown (ComponentEvent e) {}
    public void componentHidden (ComponentEvent e) {}

    public void componentResized (ComponentEvent e) {
	myReshape (getSize ().width, getSize ().height);
        display ();
	repaint ();
    }

    private void myReshape (int w, int h) {
	myGL.glViewport (0, 0, w, h);		/* define the viewport */
	myGL.glMatrixMode (GL.GL_PROJECTION);	/* prepare for and then */
	myGL.glLoadIdentity ();			/* define the projection */
	myGL.glFrustum (-1.0f,  1.0f,		/* transformation */
			-1.0f,  1.0f,
			 1.5f, 20.0f);
	myGL.glMatrixMode (GL.GL_MODELVIEW);	/* back to modelview matrix */
    }
	
    public void update (Graphics g) { paint (g); }
    public void paint (Graphics g) { myUT.glutSwapBuffers (g, this); }


    private void display () {
	myGL.glClear (GL.GL_COLOR_BUFFER_BIT);
	myGL.glColor3f (0.0f, 1.0f, 1.0f);
	
	/* clear the matrix */
	myGL.glLoadIdentity ();	

	/* viewing transformation  */
	myGL.glTranslatef (-0.5f, 0.7f, -6.0f);

	myGL.glRotatef(40.0f, 0.0f, 1.0f, 0.0f);
	myGL.glRotatef(20f, 1.0f, 0.0f, 0.0f);

	myGL.glRotatef(20.0f, 1.0f, 0.0f, 1.0f);

	/* modeling transformation */ 
	myGL.glScalef (.105f, .105f, .105f);	

	desenhaLinhas();

	myGL.glFlush ();
    }

    // Devolve a chave da linha no Hash.
    private String linha2String(Linha l){
	Ponto3D p1, p2;
	p1 = l.getP1();
	p2 = l.getP2();
	String s = 
	    Float.toString(p1.getX()) + "&" + 
	    Float.toString(p1.getY()) + "&" + 
	    Float.toString(p1.getZ()) + "->" + 
	    Float.toString(p2.getX()) + "&" + 
	    Float.toString(p2.getY()) + "&" +  
	    Float.toString(p2.getZ());

	return s;
    }
    
    public void insereLinha(Linha l){
	// Soh devo colocar se j no tiver esta linha com os pontos
	// invertidos. Se for a mesma linha, ser substituda.
	Linha tmp;

	Cor atual;

	String s = linha2String(l);

	// Verifica se esta no hash no formato dado
	if(linhas.containsKey(s)){
	    // S preciso colocar a cor atual como anterior e a cor da
	    // nova linha como atual.
	    tmp = (Linha)linhas.get(s);

	    atual = tmp.getCor();
	    tmp.setCor(l.getCor());
	    tmp.getCor().setAnterior(atual);
	}
	else{ // Se nao esta no formato dado, ou esta no invertido ou
              // nao esta. Podemos colocar esta nova linha no invertido,
              // substituindo alguma possivel anterior.
	    Linha l2 = new Linha(l.getP2(), l.getP1(), l.getCor());
	    s = linha2String(l2);

	    if(linhas.containsKey(s)){
		// S preciso colocar a cor atual como anterior e a cor da
		// nova linha como atual.
		tmp = (Linha)linhas.get(s);

		atual = tmp.getCor();
		tmp.setCor(l2.getCor());
		tmp.getCor().setAnterior(atual);
	    }
	    else{
		// Preciso adicionar a linha no hash
		linhas.put(s, l2);
	    }
	}

	display();
	repaint();
    }

    public void removeLinha(Linha l){
	String s;
	Linha l2, tmp;
	
	// Acho qual linha do Hash a linha dada se refere.
	s = linha2String(l);
	tmp = (Linha)linhas.get(s);
	if (tmp == null) {
	    l2 = new Linha(l.getP2(), l.getP1(), l.getCor());
	    s = linha2String(l2);
	    tmp = (Linha)linhas.get(s);
	}
	
	// Tiro a linha se nao tiver anterior (ou seja, eh uma linha canditada)
	if (tmp != null){
	    if(tmp.getCor().getAnterior() == null){
		linhas.remove(s);
	    }
	    else{ // A linha pertencia ao fecho convexo

		// Coloco a cor anteiror no lugar da atual.
		tmp.setCor(tmp.getCor().getAnterior());
	    }
	}
	display();
	repaint();
    }


    // Retira a linha independente de qq coisa.
    public void arrancaLinha(Linha l){
	Linha l2;
	linhas.remove(linha2String(l));
	l2 = new Linha(l.getP2(), l.getP1(), l.getCor());
	linhas.remove(linha2String(l2));
	display();
	repaint();
    }


    private void desenhaLinhas(){
	Enumeration conjunto;
	Linha l;
	Cor c;

	conjunto = linhas.elements();

	myGL.glBegin(myGL.GL_LINES);
	
	while (conjunto.hasMoreElements()){
	    l = (Linha)conjunto.nextElement();
	    c = l.getCor();
	    myGL.glColor3f (c.getR(), c.getG(), c.getB());	
	    myGL.glVertex3f(l.getP1().getX(), l.getP1().getY(), l.getP1().getZ());
	    myGL.glVertex3f(l.getP2().getX(), l.getP2().getY(), l.getP2().getZ());
	}
	myGL.glEnd();
    }
    

    // Aqui inserimos um cubo para representar um ponto, por simplicidade.
    public void inserePonto(Ponto3D p){
	float raio = (float).1;
	Cor c = new Cor(1.0f, 0.0f, 0.0f);


	Ponto3D p1 = new Ponto3D(p.getX()-raio, p.getY()-raio, p.getZ()-raio);
	Ponto3D p2 = new Ponto3D(p.getX()-raio, p.getY()+raio, p.getZ()-raio);
	Ponto3D p3 = new Ponto3D(p.getX()+raio, p.getY()+raio, p.getZ()-raio);
	Ponto3D p4 = new Ponto3D(p.getX()+raio, p.getY()-raio, p.getZ()-raio);
	Ponto3D p5 = new Ponto3D(p.getX()-raio, p.getY()-raio, p.getZ()+raio);
	Ponto3D p6 = new Ponto3D(p.getX()-raio, p.getY()+raio, p.getZ()+raio);
	Ponto3D p7 = new Ponto3D(p.getX()+raio, p.getY()+raio, p.getZ()+raio);
	Ponto3D p8 = new Ponto3D(p.getX()+raio, p.getY()-raio, p.getZ()+raio);

	insereLinha(new Linha(p1, p2, c));
	insereLinha(new Linha(p2, p3, c));
	insereLinha(new Linha(p3, p4, c));
	insereLinha(new Linha(p4, p1, c));
	insereLinha(new Linha(p5, p6, c));
	insereLinha(new Linha(p6, p7, c));
	insereLinha(new Linha(p7, p8, c));
	insereLinha(new Linha(p8, p5, c));
	insereLinha(new Linha(p1, p5, c));
	insereLinha(new Linha(p2, p6, c));
	insereLinha(new Linha(p3, p7, c));
	insereLinha(new Linha(p4, p8, c));
    }

    private void principal(){
	Embrulho embrulho = new Embrulho(this);
	embrulho.setTSleep(tsleep);
	embrulho.Algoritmo();
    }
}
